/*
 *    snake - a videogame derived from Q-Basic nibbles
 *    Copyright (C) 1999 Cyberandro J.K. Starrik
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "sins.h"

/* public functions */
int wall_module_init (void);
int CMD_wall (char *);

/* private data */
wall stdwall;

/* private functions */
static int parse_function (char *, int);
  

int
wall_module_init ()
{
  stdwall.type = WALL;
  if (!register_command("wall", &CMD_wall, "wall <func>")) return 0;
  return 1;
}

int
CMD_wall (char *func)
{
  int x, y;

  if ( !func ) return -1;

  if ( ! screen_initialized ) return 0;

  for (x=0; x<ARENA_WIDTH; x++)
  {
    y = parse_function (func, x);
    if ( y >= ARENA_HEIGHT ) continue;
    ARENAPUT( y, x, (sprite *) &stdwall );
  }

  /* ARENAPUT (100, 10, (sprite *) &stdwall ); */
  return 1;
}

static int
parse_function (char *func, int x)
{
  char *format = "%d %c %d";
  int v1, v2;
  char operand;

  if ( sscanf (func, format, &v1, &operand, &v2) )
  {
    switch ( operand )
    {
      case '+':
        return v1+v2;
      case '-':
        return v1-v2;
      case '*':
        return v1*v2;
      case '/':
        return v1/v2;
      case '%':
        return v1%v2;
      default:
        message ("Unknown operand %c", operand);
        break;
    }
  }

  else
  {
    message ("malformed function");
    return ARENA_HEIGHT+10;
  }
}

